import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkUsersLog, ThinkUsersLogParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkUsersLog(params: ThinkUsersLogParam) {
  const res = await request.get<ApiResult<PageResult<ThinkUsersLog>>>(
    THINK_API_URL + '/think/think-users-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkUsersLog(params?: ThinkUsersLogParam) {
  const res = await request.get<ApiResult<ThinkUsersLog[]>>(
    THINK_API_URL + '/think/think-users-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkUsersLog(data: ThinkUsersLog) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkUsersLog(data: ThinkUsersLog) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkUsersLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkUsersLog(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkUsersLog(id: number) {
  const res = await request.get<ApiResult<ThinkUsersLog>>(
    THINK_API_URL + '/think/think-users-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
